Strict
'Entweder ihr habt bei Euch das Modul minib3d installiert,
'dann brauch ihr nur die Zeile: "Import sidesign.minib3d"
'Ansonsten muesst ihr eben dies hier compilieren lassen, was einige Zeit dauert:
'==============================================================================
Import BRL.GLMax2D
Import BRL.GLGraphics
Import PUB.Glew
Import BRL.BMPLoader
Import BRL.PNGLoader
Import BRL.JPGLoader
Import BRL.Retro
Import "etc/codes/sidesign/minib3d/inc/std.cpp"
Import "etc/codes/sidesign/minib3d/inc/misc.cpp"		' contains C_UpdateNormals and C_IntersectTriangle
Import "etc/codes/sidesign/minib3d/inc/collision.cpp"	' contains functions used by TCollisionB.bmx
Import "etc/codes/sidesign/minib3d/inc/tree.cpp"		' contains functions used by TCollisionB.bmx
Import "etc/codes/sidesign/minib3d/inc/geom.cpp"		' contains functions used by TCollisionB.bmx
Include "etc/codes/sidesign/minib3d/minib3d.bmx"
'==============================================================================
'Ab hier ist wieder alles notwendig:
Include "etc/codes/LoadPixmapTexture.bmx"	'(enthaelt eine manipulierte minib3d-LoadTexture-Function)
SeedRnd MilliSecs()
Global timer:TTimer = CreateTimer(60)
Global program_starting:Byte = True
'_______________________________________________________
AppTitle = "ABC-Schtze"
Graphics3D 1000,700,0,2
'_______________________________________________________
Local pivot:TPivot = CreatePivot()
PositionEntity(pivot, 0, 0, 0)
Global camera:TCamera = CreateCamera(pivot)
Local camera_distance:Int = -14
PositionEntity(camera, 0, 0,camera_distance)
Local light:TLight = CreateLight() '(parameter 1-3)
RotateEntity light,75,15,0
'_______________________________________________________
Global WallBorder:Int = 6
Local Bricks:TTexture = LoadTexture("etc/images/Bricks.png")
ScaleTexture(Bricks, 0.2, 0.2)
Local FloorGrey:TTExture = LoadTexture("etc/images/Floor.png")
ScaleTexture(FloorGrey, 0.15, 0.15)
Local Ceiling:TTExture = LoadTexture("etc/images/Top.png")
Local Wall:TEntity[5]
For Local w% = 0 To 4
	Wall[w] = CreateCube()
Next
ScaleEntity(Wall[0], 1.5*WallBorder+1, 0, WallBorder)
PositionEntity(Wall[0], 0, -WallBorder-1, 0)
EntityTexture(Wall[0], FloorGrey)
ScaleEntity(Wall[1], 0, WallBorder+1, WallBorder)
PositionEntity(Wall[1], -1.5*WallBorder-1, 0, 0)
EntityTexture(Wall[1], Bricks)
ScaleEntity(Wall[2], 1.5*WallBorder+1, 0, WallBorder)
PositionEntity(Wall[2], 0, +WallBorder+1, 0)
EntityTexture(Wall[2], Ceiling)
ScaleEntity(Wall[3], 0, WallBorder+1, WallBorder)
PositionEntity(Wall[3], 1.5*WallBorder+1, 0, 0)
EntityTexture(Wall[3], Bricks)
ScaleEntity(Wall[4], 1.5*WallBorder+1, WallBorder+1, 0)
PositionEntity(Wall[4], 0, 0, WallBorder)
EntityTexture(Wall[4], Bricks)
'_______________________________________________________
Local font:TImageFont = LoadImageFont("etc/font/linux-truetypefonts/msttcorefonts/Arial (NICHT von Windows, kostenlos in ubuntu).ttf", 70)
SetImageFont(font)
'_______________________________________________________
Renderworld()
Renderworld()
BeginMax2D()
SetBlend ALPHABLEND
DrawText "ABC-Schtze", 300, 70
SetScale 0.5, 0.5
DrawText "Fange die Buchstabenblle in alphabetischer Reihenfolge!", 50, 224
DrawText "Richtig gefangene Buchstabenblle bewegen sich nicht mehr.", 19, 277
DrawText "Bewegende Blle tauschen beim Kollidieren ihre Buchstaben.", 21, 329
DrawText "Wenn alle Blle gefangen sind und sich keiner mehr bewegt,", 28, 380
DrawText "gelangt man in den nchsten Level mit jeweils zwei Bllen", 54, 431
DrawText "mehr. Die Blle sind jeweils ein bisschen kleiner und schneller.", 19, 481
DrawText "Klickt man auf einen falschen Buchstaben, verliert man den", 31, 528
DrawText "zuletzt gefangenen Ball und muss ihn wieder neu fangen.", 66, 573
DrawText "Starte nun das Spiel mit Mausklick. Viel Spa!", 152, 628
SetScale 1,1
EndMax2D()
Flip
Global Music:TSound = LoadSound("etc/sounds/Music.ogg")
'_______________________________________________________
Global MusicChannel:TChannel, CountMusicRepetitions%
'_______________________________________________________
Global hands:TImage = LoadAnimImage("etc/images/hands.png", 78, 81, 0, 2)
MidHandleImage(hands)
Global hand_animation_start_time%, hand_x%, hand_y%, hand_frame%, hand_y_way%, hand_scale#, hand_letter%
Local Ok:TSound = LoadSound("etc/sounds/Ok.ogg")
Local Failure:TSound = LoadSound("etc/sounds/Failure.ogg")
Global NewLevel:TSound = LoadSound("etc/sounds/NewLevel.ogg")
Global LastLevel:TSound = LoadSound("etc/sounds/LastLevel.ogg")
'_______________________________________________________
Global BallTexture:TTexture[26]
BeginMax2D()
Local Pixmap:TPixmap
Local BallTextureBackground:TImage = LoadImage("etc/images/BallSurface.png")
For Local Letter:Int = 0 Until 26
	DrawImage BallTextureBackground, 0, 0
	SetColor 255,255,255
	DrawText Chr(Letter+65), 80, 80
	Pixmap = GrabPixmap(0,0,200,200)
	BallTexture[Letter] = LoadPixmapTexture(Pixmap)
	ScaleTexture(BallTexture[Letter], 0.5, 0.5)
Next
EndMax2D()

Repeat
	WaitTimer(timer)
	If AppTerminate() Then End
Until MouseHit(1) Or KeyHit(KEY_ESCAPE)
If Music <> Null Then MusicChannel = PlaySound(Music)

Global CountBalls%, CountCorrectCaughtBalls%, FlyingBall:TFlyingBall[26]
CreateNewBalls(4)


Function CreateNewBalls(NewCountBalls%)
	If program_starting = False Then 'Ausblenden (nicht am Anfang)
		Local value#, time% = MilliSecs()
		value = value*value
		Repeat
			value = 1 - (MilliSecs()-time)/1000.0
			Local fb% = 0
			Repeat
				EntityAlpha(FlyingBall[fb].Entity, value)
				EntityAlpha(FlyingBall[fb].Shade, value * (0.1 - 0.1*(FlyingBall[fb].y+WallBorder) / WallBorder))
				fb:+1
			Until fb = 26 Or FlyingBall[fb] = Null Or FlyingBall[fb].Entity = Null
			UpdateWorld()
			Renderworld()
			BeginMax2D()
			SetBlend ALPHABLEND
			SetAlpha value
			SetScale hand_scale, hand_scale
			DrawText Chr(hand_letter), hand_x+hand_scale*12, hand_y - hand_scale*32 - (1-value) * hand_y_way
			DrawImage hands, hand_x-12, hand_y - (1-value) * hand_y_way, hand_frame
			EndMax2D()
			Flip
			WaitTimer(timer)
		Until value <= 0
	End If
	For Local fb% = 0 Until 26
		If FlyingBall[fb] <> Null Then
			FreeEntity(FlyingBall[fb].Entity)
			FreeEntity(FlyingBall[fb].Shade)
			FlyingBall[fb].Entity = Null
			FlyingBall[fb] = Null
		End If
	Next
	If NewCountBalls <= 26 Then
		CountBalls = NewCountBalls
	Else
		Local time% = MilliSecs()
		While Not MouseHit(1)
			Renderworld()
			BeginMax2D()
			SetBlend ALPHABLEND
			If Music <> Null And ChannelPlaying(MusicChannel) Then
				If MilliSecs()-time < 1500 Then
					SetChannelVolume(MusicChannel, 1 - (MilliSecs()-time) / 1500.0)
				Else
					StopChannel(MusicChannel)
					PlaySound(LastLevel)
				End If
			End If
			If MilliSecs()-time < 1500 Then
				SetAlpha (MilliSecs()-time) / 1500.0
				SetScale 1, 1
			Else
				SetScale 1, 1
				DrawImage hands, 140, 360, 0
				DrawImage hands, 841, 360, 0
			End If
			DrawText "ABC-Schtze", 300, 70
			SetScale 0.5, 0.5
			DrawText "BRAVO, BRAVISSIMO!", 311, 230
			DrawText "Du hast im hchsten Level", 300, 310
			DrawText "alle 26 Buchstabenblle in der", 264, 370
			DrawText "richtigen Reihenfolge gefangen!", 248, 430
			DrawText "Wieder neu starten mit Mausklick.", 240, 628
			EndMax2D()
			Flip
			If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
			WaitTimer(timer)
		Wend
		If Music <> Null Then MusicChannel = PlaySound(Music)
		CountBalls = 4
	End If
	CountCorrectCaughtBalls = 0
	For Local fb% = 0 Until CountBalls
		FlyingBall[fb] = TFlyingBall.Create(fb)
		Local new_x#, new_y#, new_z#, engaged:Byte
		Repeat
			new_x = Rand(-1.5*WallBorder + FlyingBall[fb].size, 1.5*WallBorder - FlyingBall[fb].size)
			new_y = Rand(-WallBorder + FlyingBall[fb].size, WallBorder - FlyingBall[fb].size)
			new_z = Rand(-WallBorder + FlyingBall[fb].size, WallBorder - FlyingBall[fb].size)
			engaged = False
			For Local eb% = 0 To fb-1
				Local QuadratDistance# = (new_x-FlyingBall[eb].x)*(new_x-FlyingBall[eb].x) + (new_y-FlyingBall[eb].y)*(new_y-FlyingBall[eb].y) + (new_z-FlyingBall[eb].z)*(new_z-FlyingBall[eb].z)
				If QuadratDistance <= 0.75 * (FlyingBall[fb].size + FlyingBall[eb].size)*(FlyingBall[fb].size + FlyingBall[eb].size) Then
					engaged = True
					Exit
				End If
			Next
		Until engaged = False
		FlyingBall[fb].x = new_x
		FlyingBall[fb].y = new_y
		FlyingBall[fb].z = new_z
		PositionEntity(FlyingBall[fb].Entity, new_x, new_y, new_z)
		Local ShadeFactor# = 0.9 + 0.6*(new_y+WallBorder) / WallBorder
		PositionEntity(FlyingBall[fb].Shade, new_x, -WallBorder-0.9, new_z)
		ScaleEntity(FlyingBall[fb].Shade, ShadeFactor*FlyingBall[fb].size,0,ShadeFactor*FlyingBall[fb].size)
		EntityAlpha(FlyingBall[fb].Shade, 0.1 - 0.1*(new_y+WallBorder) / WallBorder)
	Next
	Local value#, time% = MilliSecs()
	If program_starting = False Then PlaySound(NewLevel)
	program_starting = False
	Repeat 'Einblenden
		value = (MilliSecs()-time)/1000.0
		value = value*value
		Local fb% = 0
		Repeat
			CameraPick(camera, -1,-1) 'wird hier noch nicht gebraucht, ansonsten gibt es aber spaeter einen Ruck, sobald es benutzt wird
			FlyingBall[fb].update()
			EntityAlpha(FlyingBall[fb].Entity, value)
			EntityAlpha(FlyingBall[fb].Shade, value * (0.1 - 0.1*(FlyingBall[fb].y+WallBorder) / WallBorder))
			fb:+1
		Until fb = 26 Or FlyingBall[fb] = Null Or FlyingBall[fb].Entity = Null
		ControlBallCollisions()
		ControlWallCollisions()
		UpdateWorld()
		Renderworld()
		Flip
		WaitTimer(timer)
	Until value >= 1
	MouseHit(1)
End Function


While Not KeyHit(KEY_ESCAPE) And Not AppTerminate()

	If Music <> Null Then
		If Not ChannelPlaying(MusicChannel) Then
			CountMusicRepetitions = (CountMusicRepetitions + 1) Mod 3
			MusicChannel = CueSound(Music)
			Select CountMusicRepetitions
			Case 0
				SetChannelRate(MusicChannel, 1)
			Case 1
				SetChannelRate(MusicChannel, 1.05555555)
			Default
				SetChannelRate(MusicChannel, 0.94444444)
			End Select
			ResumeChannel(MusicChannel)
		End If
	End If

	Local Mouse_X% = MouseX()
	Local Mouse_Y% = MouseY()
	Local MouseTouchedBall:Byte = 255
	For Local f:Byte = 0 Until CountBalls
		If CameraPick(camera, Mouse_X, Mouse_Y) = FlyingBall[f].Entity Then MouseTouchedBall = f
		FlyingBall[f].update()
	Next
	
	Local MouseAction:Byte = MouseHit(1)
	If MouseAction > 0 Then
		If MouseTouchedBall < 255 Then
			
			If FlyingBall[MouseTouchedBall].Letter = CountCorrectCaughtBalls Then
				FlyingBall[MouseTouchedBall].caught = True
				CountCorrectCaughtBalls:+1
				hand_animation_start_time = MilliSecs()
				hand_x = Mouse_X
				hand_y = Mouse_Y
				hand_frame = 0
				hand_y_way = 100
				hand_scale = 0.75 - 0.5 * FlyingBall[MouseTouchedBall].z / WallBorder
				hand_letter = FlyingBall[MouseTouchedBall].letter + 65
				PlaySound(Ok)
				If CountCorrectCaughtBalls = CountBalls Then CreateNewBalls(CountBalls+2)
			Else
				hand_animation_start_time = MilliSecs()
				hand_x = Mouse_X
				hand_y = Mouse_Y
				hand_frame = 1
				hand_y_way = -100
				hand_scale = 0.75 - 0.5 * FlyingBall[MouseTouchedBall].z / WallBorder
				hand_letter = FlyingBall[MouseTouchedBall].letter + 65
				PlaySound(Failure)
				CountCorrectCaughtBalls = Max(0, CountCorrectCaughtBalls-1)
				For Local i% = 0 To 25
					If FlyingBall[i] = Null Then Exit
					If FlyingBall[i].caught = True Then
						If FlyingBall[i].Letter = CountCorrectCaughtBalls Then
							FlyingBall[i].caught = False
							Exit
						End If
					End If
				Next
			End If

		End If
	End If
	
	ControlBallCollisions()
	ControlWallCollisions()

	UpdateWorld()
	Renderworld()
	If hand_animation_start_time <> 0 Then
		BeginMax2D()
		SetBlend ALPHABLEND
		Local value# = (MilliSecs() - hand_animation_start_time) / 1000.0
		If value < 1 Then
			SetAlpha 1 - value
			SetScale hand_scale, hand_scale
			DrawText Chr(hand_letter), hand_x+hand_scale*12, hand_y - hand_scale*32 - value * hand_y_way
			DrawImage hands, hand_x-12, hand_y - value * hand_y_way, hand_frame
		Else
			hand_animation_start_time = 0
		End If
		EndMax2D()
	End If
	Flip
	WaitTimer(timer)
Wend

Function ControlBallCollisions()
	For Local i% = 0 Until CountBalls-1
		For Local j% = i+1 Until CountBalls
		
			Local QuadratDistance# = (FlyingBall[i].x-FlyingBall[j].x)*(FlyingBall[i].x-FlyingBall[j].x) + (FlyingBall[i].y-FlyingBall[j].y)*(FlyingBall[i].y-FlyingBall[j].y) + (FlyingBall[i].z-FlyingBall[j].z)*(FlyingBall[i].z-FlyingBall[j].z)
			If QuadratDistance <= 0.75 * (FlyingBall[i].size + FlyingBall[j].size)*(FlyingBall[i].size + FlyingBall[j].size) Then
				
				If FlyingBall[i].caught = False And FlyingBall[i].collision_with[j] = False Then
					If FlyingBall[j].caught = False And FlyingBall[j].collision_with[i] = False Then
						Local memo_StepX# = FlyingBall[i].StepX
						Local memo_StepY# = FlyingBall[i].StepY
						Local memo_StepZ# = FlyingBall[i].StepZ
						Local memo_Letter:Byte = FlyingBall[i].Letter
						FlyingBall[i].StepX = FlyingBall[j].StepX
						FlyingBall[i].StepY = FlyingBall[j].StepY
						FlyingBall[i].StepZ = FlyingBall[j].StepZ
						FlyingBall[i].Letter = FlyingBall[j].Letter
						EntityTexture(FlyingBall[i].Entity, BallTexture[FlyingBall[i].Letter])
						FlyingBall[i].collision_with[j] = True
						FlyingBall[j].StepX = memo_StepX
						FlyingBall[j].StepY = memo_StepY
						FlyingBall[j].StepZ = memo_StepZ
						FlyingBall[j].Letter = memo_Letter
						EntityTexture(FlyingBall[j].Entity, BallTexture[FlyingBall[j].Letter])
						FlyingBall[j].collision_with[i] = True
					Else
						FlyingBall[i].StepX = -FlyingBall[i].StepX
						FlyingBall[i].StepY = -FlyingBall[i].StepY
						FlyingBall[i].StepZ = -FlyingBall[i].StepZ
						FlyingBall[i].collision_with[j] = True
					End If
				ElseIf FlyingBall[j].collision_with[i] = False Then
					FlyingBall[j].StepX = -FlyingBall[j].StepX
					FlyingBall[j].StepY = -FlyingBall[j].StepY
					FlyingBall[j].StepZ = -FlyingBall[j].StepZ
					FlyingBall[j].collision_with[i] = True
				End If

			Else
			
				FlyingBall[i].collision_with[j] = False
				FlyingBall[j].collision_with[i] = False
			
			End If
		Next
	Next
End Function

Function ControlWallCollisions()
	For Local i% = 0 Until CountBalls
		If FlyingBall[i].x =< -1.5*WallBorder-1+FlyingBall[i].size Then
			FlyingBall[i].StepX = Abs(FlyingBall[i].StepX)
		ElseIf FlyingBall[i].x >= 1.5*WallBorder+1-FlyingBall[i].size Then
			FlyingBall[i].StepX = -Abs(FlyingBall[i].StepX)
		End If
		If FlyingBall[i].y =< -WallBorder-1+FlyingBall[i].size Then
			FlyingBall[i].StepY = Abs(FlyingBall[i].StepY)
		ElseIf FlyingBall[i].y >= WallBorder+1-FlyingBall[i].size Then
			FlyingBall[i].StepY = -Abs(FlyingBall[i].StepY)
		End If
		If FlyingBall[i].z =< -WallBorder+FlyingBall[i].size Then
			FlyingBall[i].StepZ = Abs(FlyingBall[i].StepZ)
		ElseIf FlyingBall[i].z >= WallBorder-FlyingBall[i].size Then
			FlyingBall[i].StepZ = -Abs(FlyingBall[i].StepZ)
		End If
	Next
End Function


Type TFlyingBall
	Field Entity:TEntity
	Field Shade:TEntity
	Field size#
	Field x#, y#, z#
	Field StepX#, StepY#, StepZ#
	Field x_rotate#, y_rotate#, z_rotate#
	Field collision_with:Byte[CountBalls]
	Field caught:Byte
	Field Letter:Byte
		
	Function Create:TFlyingBall(Letter:Byte)
		Local NewFlyingBall:TFlyingBall = New TFlyingBall
		NewFlyingBall.Entity = CreateSphere(16)
		EntityPickmode(NewFlyingBall.Entity, 1)
		NewFlyingBall.Letter = Letter
		EntityTexture(NewFlyingBall.Entity, BallTexture[Letter])
		Select CountBalls
		Case 4
			Entitycolor(NewFlyingBall.Entity, 200,200,200)
		Case 6
			Entitycolor(NewFlyingBall.Entity, 96,96,255)
		Case 8
			Entitycolor(NewFlyingBall.Entity, 0,200,0)
		Case 10
			Entitycolor(NewFlyingBall.Entity, 255,0,255)
		Case 12
			Entitycolor(NewFlyingBall.Entity, 255,255,0)
		Case 14
			Entitycolor(NewFlyingBall.Entity, 255,0,0)	
		Case 16
			Entitycolor(NewFlyingBall.Entity, 0,255,128)
		Case 18
			Entitycolor(NewFlyingBall.Entity, 0,255,255)
		Case 20
			Entitycolor(NewFlyingBall.Entity, 255,0,128)
		Case 22
			Entitycolor(NewFlyingBall.Entity, 0,128,255)
		Case 24
			Entitycolor(NewFlyingBall.Entity, 128,255,0)
		Case 26
			Entitycolor(NewFlyingBall.Entity, 255,128,0)
		End Select
		NewFlyingBall.size = 2.5 - 1.5*(CountBalls-4) / 22.0
		ScaleEntity(NewFlyingBall.Entity, NewFlyingBall.size, NewFlyingBall.size, NewFlyingBall.size)
		EntityRadius(NewFlyingBall.Entity, NewFlyingBall.size, NewFlyingBall.size)
		EntityShininess(NewFlyingBall.Entity, 1)
		Local Speed# =  0.5 + CountBalls / 26.0
		NewFlyingBall.StepX = Speed * (-0.05 + 0.1*Rnd())
		NewFlyingBall.StepY = Speed * (-0.05 + 0.1*Rnd())
		NewFlyingBall.StepZ = Speed * (-0.05 + 0.1*Rnd())
		NewFlyingBall.x_rotate = Speed * (-0.5 + Rnd())
		NewFlyingBall.y_rotate = Speed * (-0.5 + Rnd())
		NewFlyingBall.z_rotate = Speed * (-0.5 + Rnd())
		NewFlyingBall.Shade = CreateSphere(8)
		EntityColor(NewFlyingBall.Shade, 0, 0, 0)
		Return NewFlyingBall
	End Function
	
	Method update()
		If caught = True Then Return
		x=x+StepX
		y=y+StepY
		z=z+StepZ
		PositionEntity(Entity, x, y, z)
		TurnEntity(Entity, x_rotate, y_rotate, z_rotate)
		Local ShadeFactor# = 0.9 + 0.6*(y+WallBorder) / WallBorder
		PositionEntity(Shade, x, -WallBorder-0.9, z)
		ScaleEntity(Shade, ShadeFactor*size,0,ShadeFactor*size)
		EntityAlpha(Shade, 0.1 - 0.1*(y+WallBorder) / WallBorder)
	End Method
	
End Type